function bpass2D
%(image_array,lnoise,lobject,threshold)
clear;
lobject = [6 6];
lnoise = [3 3];
threshold = 0;
head = 0;
tfinal = 10000;

bigpath = char('/Volumes/Database/2D_grain_boundary.mdb/');

pathlist = ...
    {'SC_zoom_14X_N10000_30fps_1/' ...
    'SC_zoom_14X_N10000_30fps_2/' ...
    'SC_zoom_14X_N10000_30fps_3/' ...
    'SC_zoom_14X_N10000_30fps_4/' ...
    'SC_zoom_14X_N10000_30fps_5/' ...
    'SC_zoom_14X_N10000_30fps_6/' ...
};

for pathCnt = 1:length(pathlist)
    
        filePath = [bigpath char(pathlist(pathCnt)) '1.tif'];
        InfoImage=imfinfo(filePath);
        mImage=InfoImage(1).Width;
        nImage=InfoImage(1).Height;
        numImgs=length(InfoImage);
        image_array = zeros(nImage,mImage,numImgs,'uint8');
        outdir = [bigpath char(pathlist(pathCnt)) '/bpass/'];
        mkdir(outdir);
        
        for i=1:numImgs
            image_array(:,:,i)=imread(filePath,'Index',i,'Info',InfoImage);
            if mod(i,100)==0
                display(i);
            end
        end

        image_array= imcomplement(image_array);
        image_array= padarray(image_array, 2*[lobject 0], 'symmetric', 'both');

    for time = 1:tfinal
        
        outPath = [outdir num2str(time) '_bp.tif'];        
       
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        if time == 1
        [kx, ky] = build_freq2d(image_array);
        end;
        %kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lobject^2)/2);
        kernel = exp(-((kx.^2)*(lobject(1)^2)/2 + (ky.^2)*(lobject(2)^2)/2));        
        highPass = real(ifftn(kernel.*fftn(image_array(:,:,time))));
        %figure; imagesc(highPass(:,:,34),[0 250]); colorbar;
        %kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lnoise^2)/2);
        kernel = exp(-((kx.^2)*(lnoise(1)^2)/2 + (ky.^2)*(lnoise(2)^2)/2));        
        lowPass = real(ifftn(kernel.*fftn(image_array(:,:,time))));
        %figure; imagesc(lowPass(:,:,34),[0 250]); colorbar;
        
        filtered = lowPass - highPass;
        threshold = graythresh(filtered);
        filtered(filtered < threshold) = 0;
        filtered = filtered * 2;
        filtered = uint8(filtered);
        filtered = filtered(1+2*lobject(1):end-2*lobject(1), ...
            1+2*lobject(2):end-2*lobject(2));
        
        %filtered = filtered(:,:,head:end);
        
        %%% cropping out the substrate image
        
        %figure; imagesc(rot90(filtered(:,:,34)'),[0 250]); colorbar;
        %figure; imshow3D(permute(filtered,[3 2 1]));
        %figure; imshow3D(filtered);
        %figure; imshow(rot90(filtered(:,:,34)'), [0 305]);
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        
        
        if (exist(outPath, 'file'))
            delete(outPath);
        end
        
        imwrite(filtered, outPath,'WriteMode', 'append');
        fprintf([outPath '\n']);
        
    end
end

end