function bpass3D
%(image_array,lnoise,lobject,threshold)

lobject = [6 6 6];
lnoise = [2 2 2];
threshold = 0;
head = 11;

bigpath = char('/Volumes/SHEAR/SALSA_2um_boundary.mdb/');

pathlist = ...
    {'p1_N150_1/' ...
    'p1_N150_2/' ...
    'p1_N150_3/' ...
    'p1_N150_4/' ...
    %'averaged_dz015_N200_2/' ...
    %'averaged_dz015_N200_3/' ...
    };

for pathCnt = 1:length(pathlist)
    
    for time = 1:150
        
        filePath = [bigpath char(pathlist(pathCnt)) num2str(time) '_non.tif'];
        outPath = [bigpath char(pathlist(pathCnt)) num2str(time) '_bp_666.tif'];
        
        InfoImage=imfinfo(filePath);
        mImage=InfoImage(1).Width;
        nImage=InfoImage(1).Height;
        numImgs=length(InfoImage);
        image_array = zeros(nImage,mImage,numImgs,'uint8');
        
        for i=1:numImgs
            image_array(:,:,i)=imread(filePath,'Index',i,'Info',InfoImage);
        end
        
        image_array= imcomplement(image_array);
        image_array= padarray(image_array, 2*lobject.*[1 1 1], 'symmetric', 'both');

        %imshow(image_array(:,:,34));
        
        %{
%%%%%%%%%%%% square mask %%%%%%%%%%%%
lnoise = 1;
lobject = 15;
[p, q, r] = size(image_array);
kernelSquare = zeros(p, q, r);
kernelSquare(1:lobject, 1:lobject, 1:lobject) = 1;
kernelSquare = kernelSquare/sum(kernelSquare(:));
highPass = real(ifftn(fftn(kernelSquare).*fftn(image_array)));
%figure; imagesc(highPass(:,:,34),[0 250]); colorbar;
[kx, ky, kz] = build_freq3d(image_array);
kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lnoise^2)/2);
lowPass = real(ifftn(kernel.*fftn(image_array)));
%figure; imagesc(lowPass(:,:,34),[0 250]); colorbar;
filtered = lowPass - highPass;
%filtered = (filtered + 256)/2;
filtered(filtered < threshold) = 0;
filtered = filtered * 2;
figure; imshow(rot90(filtered(:,:,34)'), [0 305]);
%%%%%%%%%%%% square mask %%%%%%%%%%%%
        %}
        
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        if time == 1
        [kx, ky, kz] = build_freq3d(image_array);
        end;
        %kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lobject^2)/2);
        kernel = exp(-((kx.^2)*(lobject(1)^2)/2 + (ky.^2)*(lobject(2)^2)/2 + (kz.^2)*(lobject(3)^2)/2));        
        highPass = real(ifftn(kernel.*fftn(image_array)));
        %figure; imagesc(highPass(:,:,34),[0 250]); colorbar;
        %kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lnoise^2)/2);
        kernel = exp(-((kx.^2)*(lnoise(1)^2)/2 + (ky.^2)*(lnoise(2)^2)/2 + (kz.^2)*(lnoise(3)^2)/2));        
        lowPass = real(ifftn(kernel.*fftn(image_array)));
        %figure; imagesc(lowPass(:,:,34),[0 250]); colorbar;
        
        filtered = lowPass - highPass;
        threshold = graythresh(filtered);
        filtered(filtered < threshold) = 0;
        filtered = filtered * 2;
        filtered = uint8(filtered);
        filtered = filtered(1+2*lobject(1):end-2*lobject(1), ...
            1+2*lobject(2):end-2*lobject(2), ...
            1+2*lobject(3):end-2*lobject(3));
        filtered = filtered(:,:,head:end);
        
        %%% cropping out the substrate image
        
        %figure; imagesc(rot90(filtered(:,:,34)'),[0 250]); colorbar;
        %figure; imshow3D(permute(filtered,[3 2 1]));
        %figure; imshow3D(filtered);
        %figure; imshow(rot90(filtered(:,:,34)'), [0 305]);
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        
        
        if (exist(outPath, 'file'))
            delete(outPath);
        end
        
        for i=1:size(filtered,3)
            imwrite(filtered(:,:,i), outPath,'WriteMode', 'append');
        end
        
        fprintf([outPath '\n']);
        
    end
end

end