function bpass3D_2
%(image_array,lnoise,lobject,threshold)

lobject = 6;
lnoise = 3;
threshold = 0;

bigpath = char('/Volumes/SHEAR/SALSA_2um.mdb/');

pathlist = ...
    {'averaged_dz015_N200_1/' ...
    'averaged_dz015_N200_2/' ...
    'averaged_dz015_N200_3/' ...
    };

for pathCnt = 1:length(pathlist)
    
    for time = 1:190
        
        filePath = [bigpath char(pathlist(pathCnt)) num2str(time) '.tif'];
        outPath = [bigpath char(pathlist(pathCnt)) num2str(time) '_bp_6.tif'];
        
        InfoImage=imfinfo(filePath);
        mImage=InfoImage(1).Width;
        nImage=InfoImage(1).Height;
        numImgs=length(InfoImage);
        image_array = zeros(nImage,mImage,numImgs,'uint8');
        
        for i=1:numImgs
            image_array(:,:,i)=imread(filePath,'Index',i,'Info',InfoImage);
        end
        
        image_array= imcomplement(image_array);
        image_array= padarray(image_array, 2*lobject*[1 1 1], 'replicate', 'both');

        %imshow(image_array(:,:,34));
        
        %{
%%%%%%%%%%%% square mask %%%%%%%%%%%%
lnoise = 1;
lobject = 15;
[p, q, r] = size(image_array);
kernelSquare = zeros(p, q, r);
kernelSquare(1:lobject, 1:lobject, 1:lobject) = 1;
kernelSquare = kernelSquare/sum(kernelSquare(:));
highPass = real(ifftn(fftn(kernelSquare).*fftn(image_array)));
%figure; imagesc(highPass(:,:,34),[0 250]); colorbar;
[kx, ky, kz] = build_freq3d(image_array);
kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lnoise^2)/2);
lowPass = real(ifftn(kernel.*fftn(image_array)));
%figure; imagesc(lowPass(:,:,34),[0 250]); colorbar;
filtered = lowPass - highPass;
%filtered = (filtered + 256)/2;
filtered(filtered < threshold) = 0;
filtered = filtered * 2;
figure; imshow(rot90(filtered(:,:,34)'), [0 305]);
%%%%%%%%%%%% square mask %%%%%%%%%%%%
        %}
        
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        [kx, ky, kz] = build_freq3d(image_array);
        kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lobject^2)/2);
        highPass = real(ifftn(kernel.*fftn(image_array)));
        %figure; imagesc(highPass(:,:,34),[0 250]); colorbar;
        kernel = exp(-(kx.^2+ky.^2+kz.^2)*(lnoise^2)/2);
        [kx, ky, kz] = build_freq3d(image_array);
         lowPass = real(ifftn(kernel.*fftn(image_array)));
        %figure; imagesc(lowPass(:,:,34),[0 250]); colorbar;
        
        filtered = lowPass - highPass;
        threshold = graythresh(filtered);
        filtered(filtered < threshold) = 0;
        filtered = filtered * 2;
        filtered = uint8(filtered);
        filtered = filtered(1+2*lobject*[1 1 1]:end-2*lobject*[1 1 1], ...
            1+2*lobject*[1 1 1]:end-2*lobject*[1 1 1], ...
            1+2*lobject*[1 1 1]:end-2*lobject*[1 1 1]);
        %figure; imagesc(rot90(filtered(:,:,34)'),[0 250]); colorbar;
        %figure; imshow3D(filtered);
        %figure; imshow(rot90(filtered(:,:,34)'), [0 305]);
        %%%%%%%%%%%% Gaussian mask %%%%%%%%%%%%
        
        
        if (exist(outPath, 'file'))
            delete(outPath);
        end
        
        for i=1:numImgs
            imwrite(filtered(:,:,i), outPath,'WriteMode', 'append');
        end
        
        fprintf([outPath '\n']);
        
    end
end

end